#ifndef SP_LIST1
#define SP_LIST1
#include "sp_names.h"
#include LS_ARRAY1_H
#include SP_LIST_H

template <class T>
class sp_list1: public sp_list<T>
{ protected:
  list1<T> *a;           // a->i: Dimension des Feldes
                         // a->next: Zeiger b auf 1. Datenelement (oder auf a)
                         // b->i: Index des 1. Datenelementes
                         // b->x: Datenelement
                         // b->next: Zeiger auf naechstes Datenlement
                         // oder auf a
  char ONAME[ls_len];    // Feld fuer den Objektnamen
  void set_data(list1<T> *aa){ a=aa;}
  public:
  char *name;            // Zeiger auf den Objektnamen
  sp_list1(ls_UINT =0, char* ="sp_list1");
  sp_list1(sp_list1<T> &);
  sp_list1(T*, ls_UINT,char* ="sp_list1");
  ~sp_list1();
  sp_list1<T>& swap(sp_list1<T> &);
  operator const ls_array1<T>()const
  { ls_array1<T> v(a->i); get_array(v); return v;}
  list1<T>* asList()const{ return a;}
  ls_UINT dimension() const{ return a->i;}
  const sp_list1<T>& operator=(const sp_list1<T> &);
  sp_list1<T>& put(T, ls_UINT=0);
  sp_list1<T>& put_array(const sp_list1<T>&, ls_UINT =0);
  sp_list1<T>& put_array(const ls_array1<T>&, ls_UINT =0);
  sp_list1<T>& put_array(T, ls_UINT =0);
  T get(ls_UINT) const;
  const sp_list1<T>& get_array(sp_list1<T>&, ls_UINT =0) const;
  const sp_list1<T>& get_array(ls_array1<T>&, ls_UINT =0) const;
  sp_list1<T>& append(ls_UINT =1);
  sp_list1<T>& remove(ls_UINT);
  sp_list1<T>& remove();
  const sp_list1<T>& write(ostream &) const;
  sp_list1<T>& read(istream &);
  const sp_list1<T>& operator>> (char *) const;
  sp_list1<T>& operator<< (char *);
};
#ifndef SP_LIB
#include SP_LIST1_C
#endif
#endif
